<!--
{{ $environments := $.Site.Params.workflow.environments | default dict }}
-->
<script>
  function filterValues(target, terms) {
    const items = target.querySelectorAll("a");
    const searchTerm = terms.toLowerCase();
    items.forEach((item) => {
      const text = item.textContent.toLowerCase();
      if (text.includes(searchTerm)) {
        item.style.display = "block";
      } else {
        item.style.display = "none";
      }
    });
  }
</script>
<template x-if="App?.Auth?.isAuthenticated()">
  <div
    x-data="{
      open: false,
      context: App.Workflow,
      known: {{ $environments | jsonify }},
      branch: null,
      refs: null,
    }"
    x-init="      
      branch = await context.getBranch();
      if (!branch) {
        refs = refs || await context.fetchBranches();
        branch = await context.getBranch();
      }
    "
  >
    <!-- Branch icon -->
    <i
      class="fa-solid fa-code-branch mr-1"
      @click="
        open = !open; 
        refs = refs || await context.fetchBranches();
        open && $nextTick(async () => document.querySelector('#branchfilter').focus());"
    ></i>

    <!-- Branch dropdown parent -->
    <div class="relative group inline-block">
      <!-- Current value -->
      <button
        type="button"
        x-show="!open"
        class="inline-flex justify-center w-full"
        @click="
          open = !open;
          refs = refs || await context.fetchBranches();
          open && $nextTick(async () => document.querySelector('#branchfilter').focus());
        "
      >
        <span x-show="!branch" class="text-gray-500 opacity-50 italic">
          Select Environment
        </span>

        <span x-show="branch" x-text="branch" class="inline-block truncate max-w-60 text-bold"></span>

        {{ partial "icons/chevron-sm.svg" . }}
      </button>

      <!-- Search input -->
      <input
        id="branchfilter"
        type="text"
        autocomplete="off"
        placeholder="Select Environment"
        class="block w-32 px-2 py-1 -my-1 text-sm text-gray-800 border border-gray-300 focus:outline-none"
        x-on:input.debounce="filterValues(document.querySelector('#branch-dropdown'), $el.value)"
        x-show="open"
        style="display: none"
      />

      <!-- Dropdown content goes here -->
      <div
        id="branch-dropdown"
        class="w-60 z-50 absolute left-0 mt-2 rounded-md shadow-lg bg-white ring-1 ring-black ring-opacity-5 p-1 space-y-1"
        x-show="open"
        @click.outside="open = false"
      >
        <!-- Well known environments -->
        <template x-for="item in Object.keys(known)">
          <a
            class="block px-4 py-2 text-gray-700 hover:bg-gray-100 active:bg-blue-100 cursor-pointer rounded-md no-underline"
            @click="branch = context.selectBranch(item); open = false;"
            x-text="known[item] || item"
            x-bind:title="known[item] || item"
            :class="{ 
            'font-bold': item === branch,
            'font-light': item !== branch,
          }"
          >
          </a>
        </template>
        <hr x-show="refs?.filter(item => !known[item])?.length" />
        <template x-for="item in refs?.filter(item => !known[item])">
          <a
            @click="branch = context.selectBranch(item); open = false;"
            class="block px-4 py-2 text-gray-700 hover:bg-gray-100 active:bg-blue-100 cursor-pointer rounded-md truncate no-underline"
            x-bind:title="known[item] || item"
            x-text="item"
            :class="{ 
            'font-bold': item === branch,
            'font-thin': item !== branch,
          }"
          >
          </a>
        </template>
      </div>
    </div>
  </div>
</template>
